<script setup lang="ts">
import type { GOAnnotationInput } from "~/utils/types/goannotation";
import { GENE_PRODUCTS } from "~/utils/types/goannotation";

const props = defineProps<{ annotation: GOAnnotationInput }>();
const emit = defineEmits<{
  (e: "update:annotation", v: GOAnnotationInput): void;
}>();
const annotation = computed(() => props.annotation);
const updateAnnotation = (updatedAnnotation: Partial<GOAnnotationInput>) => {
  emit("update:annotation", { ...annotation.value, ...updatedAnnotation });
};

const rules = {
  evidence: [(v: any) => !!v || "Evidence code is required"],
  pmid: [(v: any) => !!v || "PubMed ID is required"],
  quotation: [(v: any) => (v || "").length <= 500 || "Quotation is too long"],
  lab: [(v: any) => !!v || "Lab is required"],
};

const hints = {
  termId: "The ID of the GO term you assign to the gene",
  evidence:
    "The evidence code describes with which method the function or location expressed by the GO term, was show for this gene product.",
  pmid: "The PubMed ID of the publication where the function or location is described for the gene product.",
  quotation:
    "If you paste here the relevant section of the reference, it is for us a great help to review your annotation. The quotation may be also be displayed to the users of iBeetle-Base.",
  name: "Name of the person who is contributing this data. The contact information can help us to clarify any question.",
  email:
    "We will use your email address only for possible questions regarding this annotation. We will never show your address or give it away.",
  namePublished:
    "If you have entered your name and agree by marking the checkbox, we might show your name on this page to honor your contribution.",
};
</script>

<template>
  <div>
    Assign a GO term to this <i>Tribolium</i> gene by filling in the fields.
    Repeat to add several GO terms. Search
    <OutLink to="https://amigo.geneontology.org/amigo/dd_browse">AmiGO</OutLink>
    for the correct GO ID. Use only the most specific term ("child terms" are
    more specific; the more general "parent" terms will be automatically
    linked). Only information based on <i>Tribolium</i> data should be entered -
    do not define terms just based on <i>Drosophila</i> knowledge. We will
    review this information and submit the annotation to the Gene Ontology
    consortium.
  </div>
  <GOAnnotationTermInput
    :model-value="annotation.term"
    @update:modelValue="
      (term: GOAnnotationInput['term']) => updateAnnotation({ term })
    "
  />
  <InputLabel text="*Gene product" />
  <v-select
    :model-value="annotation.geneProduct"
    :items="GENE_PRODUCTS"
    @update:modelValue="
      (geneProduct: GOAnnotationInput['geneProduct']) =>
        updateAnnotation({ geneProduct })
    "
  />
  <InputLabel
    text="*Evidence code:"
    :help="hints.evidence"
    link="http://geneontology.org/docs/guide-go-evidence-codes/"
  />
  <v-text-field
    :model-value="annotation.evidence"
    :rules="rules.evidence"
    placeholder="e.g. IMP"
    @update:modelValue="
      (evidence: GOAnnotationInput['evidence']) =>
        updateAnnotation({ evidence })
    "
  />
  <InputLabel text="*PubMed ID:" :help="hints.pmid" />
  <PubmedInput
    :pmid="annotation.pmid"
    required
    @update:pmid="
      (pmid: GOAnnotationInput['pmid']) => updateAnnotation({ pmid })
    "
  />
  <InputLabel text="Quotation:" :help="hints.quotation" />
  <v-textarea
    :model-value="annotation.quotation"
    :rules="rules.quotation"
    placeholder="Relevant section from the publication"
    @update:modelValue="
      (quotation: GOAnnotationInput['quotation']) =>
        updateAnnotation({ quotation })
    "
  />
  <InputLabel text="*Lab name:" />
  <v-text-field
    :model-value="annotation.lab"
    :rules="rules.lab"
    @update:modelValue="
      (lab: GOAnnotationInput['lab']) => updateAnnotation({ lab })
    "
  />
</template>
